clear all;

%Initial guess
x = [5 0.1];

%Termination condition
maxiter=100;

%Trajectory
points=zeros(maxiter,2);

for i=1:1:maxiter
  if i==1
    [current,g,H] = hard(x);
    best=current;
    solution = x;
  else
    %choose direction
    d = -(inv(H)*g')';
    %choose stepsize
    alpha = 1;
    %update
    x = x + alpha.*d;
    %evaluate
    [current,g,H] = hard(x);
    
    if current < best
      best=current;
      solution = x;
    end 
   end
   %Keeping track of trajectory
   points(i,1)=x(1);
   points(i,2)=x(2);
   disp(['Iteration =' num2str(i) ' Obj. function value = ' num2str(current) ' Current point = ' num2str(x) ]);
end

solution
best
plot(points(:,1),points(:,2),'*-');